VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IrregularListArray"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private TopRow As IrregularArrayRow

' Create the linked list of rows.
Public Sub InitializeRows(ByVal rows As Integer)
Dim i As Integer
Dim new_row As IrregularArrayRow

    Set TopRow = Nothing
    For i = 1 To rows
        ' Create a new row header.
        Set new_row = New IrregularArrayRow
        Set new_row.NextRow = TopRow
        Set TopRow = new_row
    Next i
End Sub
' Give this row the indicated number of columns.
Public Sub InitializeRow(ByVal Row As Integer, ByVal cols As Integer)
Dim i As Integer
Dim new_cell As IrregularArrayCell
Dim row_hdr As IrregularArrayRow

    ' Find the row header.
    Set row_hdr = TopRow
    For i = 2 To Row
        Set row_hdr = row_hdr.NextRow
    Next i
    
    ' Create the desired number of cells.
    Set row_hdr.FirstInRow = Nothing
    For i = 1 To cols
        ' Create a new cell.
        Set new_cell = New IrregularArrayCell
        Set new_cell.NextCol = row_hdr.FirstInRow
        Set row_hdr.FirstInRow = new_cell
    Next i
End Sub
' Get the value for Array(row, col).
Public Property Get Value(ByVal Row As Integer, ByVal Col As Integer) As String
Dim row_hdr As IrregularArrayRow
Dim cell As IrregularArrayCell
Dim i As Integer

    ' Find the row.
    Set row_hdr = TopRow
    For i = 2 To Row
        If row_hdr Is Nothing Then Exit For
        Set row_hdr = row_hdr.NextRow
    Next i
    If row_hdr Is Nothing Then
        MsgBox "Invalid row number"
        Exit Property
    End If
    
    ' Find the column.
    Set cell = row_hdr.FirstInRow
    For i = 2 To Col
        If cell Is Nothing Then Exit For
        Set cell = cell.NextCol
    Next i
    If cell Is Nothing Then
        MsgBox "Invalid column number"
        Exit Property
    End If
    
    Value = cell.Value
End Property
' Save the value for Array(row, col).
Public Property Let Value(ByVal Row As Integer, ByVal Col As Integer, ByVal new_value As String)
Dim row_hdr As IrregularArrayRow
Dim cell As IrregularArrayCell
Dim i As Integer

    ' Find the row.
    Set row_hdr = TopRow
    For i = 2 To Row
        If row_hdr Is Nothing Then Exit For
        Set row_hdr = row_hdr.NextRow
    Next i
    If row_hdr Is Nothing Then
        MsgBox "Invalid row number"
        Exit Property
    End If
    
    ' Find the column.
    Set cell = row_hdr.FirstInRow
    For i = 2 To Col
        If cell Is Nothing Then Exit For
        Set cell = cell.NextCol
    Next i
    If cell Is Nothing Then
        MsgBox "Invalid column number"
        Exit Property
    End If
    
    cell.Value = new_value
End Property

